<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:f="jakarta.faces.core"
	xmlns:h="jakarta.faces.html"
	xmlns:ui="jakarta.faces.facelets"
	xmlns:p="http://primefaces.org/ui">
<head>
<title></title>
</head>
<body>
	<f:metadata>
		<f:event type="jakarta.faces.event.PreRenderViewEvent"
            listener="#{discoveryLoginBean.preRenderView}" />
	</f:metadata>
<ui:composition template="/template/default.xhtml">
	<ui:param name="title" value="#{messages.title}"/>

	<ui:define name="metadata">
		<meta http-equiv="refresh" content="600;url=index.xhtml" />	
	</ui:define>

	<ui:define name="content">
	
	<h:form id="form" prependId="false" class="full">
		<h3 class="margin-bottom"><h:outputText value="#{messages.welcome}"/></h3>

		<h:panelGroup layout="block" styleClass="text-danger text" rendered="#{sessionManager.originalRequestPath != null and sessionManager.originalRequestPath.startsWith('/idp-debug-login/')}">
			Login debugging is on. You will see a full log of your login process.
		</h:panelGroup>
	
		<h:panelGroup layout="block" styleClass="text" rendered="#{empty discoveryLoginBean.spMetadata and empty discoveryLoginBean.clientConfig}">
			<h:outputText value="#{messages.welcome_disco}" escape="false"/>
		</h:panelGroup>
		
		<h:panelGroup layout="block" rendered="#{not empty discoveryLoginBean.spMetadata}">
			<h:outputText value="#{messages.welcome_redirected}" /><br/>
			<b>
				<h:outputText value="#{discoveryLoginBean.spMetadata.displayName}" rendered="#{not empty discoveryLoginBean.spMetadata.displayName}" />
				<h:outputText value="#{discoveryLoginBean.spMetadata.entityId}" rendered="#{empty discoveryLoginBean.spMetadata.displayName}" />
			</b>			
		</h:panelGroup>

		<h:panelGroup layout="block" rendered="#{not empty discoveryLoginBean.clientConfig}">
			<h:outputText value="#{messages.welcome_redirected}" /><br/> 
			<b> 
				<h:outputText value="#{discoveryLoginBean.clientConfig.displayName}" rendered="#{not empty discoveryLoginBean.clientConfig.displayName}" />
				<h:outputText value="#{discoveryLoginBean.clientConfig.name}" rendered="#{empty discoveryLoginBean.clientConfig.displayName}" />
			</b>
		</h:panelGroup>

		<div><p:messages showDetail="true" /></div>

		<div class="grid" style="margin-top: 1em;">
			<div class="col-12 xs:col-12 sm:col-12 md:col-6 lg:col-6 xl:col-6">
				<h:panelGroup rendered="#{discoveryLoginBean.largeList}" class="autocomplete-container">
					<p:focus conext="baseData" for="searchAutocompl" />
					<span class="ui-float-label">
		                <p:autoComplete id="searchAutocompl" multiple="false" value="#{discoveryLoginBean.selected}" converter="#{userProvisionerCachedEntryConverter}" 
		                                var="idp" itemLabel="#{idp.displayName}" itemValue="#{idp}" cache="true" minQueryLength="2"
		                                completeMethod="#{discoveryLoginBean.search}" maxResults="10" 
		                                forceSelection="true" style="width: 100%; min-width: 100%; box-sizing: border-box;" onfocus="this.select();" update="infoPnl">
		                            
							<p:column style="background-color: white; padding: 0.5rem 0.5rem; text-align: center; vertical-align: middle; width: 4rem">
								<p:graphicImage style="max-width: 48px; max-height: 32px; transform: scale(1.4)"
							              		value="#{request.contextPath}/rest/icon-cache/async/small/#{idp.iconId}" rendered="#{not empty idp.iconId}"
							            	    onerror="this.style.display='none'" />
							</p:column>
							<p:column style="font-size: 1.2rem; color: black;">#{idp.displayName}</p:column>
							<p:ajax update=":form" oncomplete="updateClearButtonVisibility();" />
						    <p:ajax event="itemSelect" update="infoPnl login" oncomplete="updateClearButtonVisibility();" />
						    <p:ajax event="clear" update="infoPnl login" oncomplete="updateClearButtonVisibility();" />
						    <p:ajax event="change" update="infoPnl" oncomplete="updateClearButtonVisibility();" />
                            <p:ajax event="blur" oncomplete="updateClearButtonVisibility();" />
						</p:autoComplete>
		                <button type="button" 
								class="autocomplete-clear-button"
		                        onclick="clearAutocomplete(); clearPanelAction()"
		                        >&#10006;</button>
		                        
		                <p:remoteCommand name="clearPanelAction" action="#{discoveryLoginBean.clearPanel}" update="infoPnl" />
		                        
						<h:outputScript target="body">
						    window.clearAutocomplete = function() {
						        var autoCompleteInput = document.getElementById('searchAutocompl_input');
						        
						        if (autoCompleteInput) {
						            autoCompleteInput.value = ''; 
						            var autoCompleteWidget = PF('searchAutocompl'); 
						            
						            if (autoCompleteWidget) {
						                autoCompleteWidget.reset(); 
						            }
						            document.querySelector('.autocomplete-clear-button').style.display = 'none';
						            document.getElementById('login').disabled = true;
						        }
						    }
						
						    function updateClearButtonVisibility() {
						          var autoCompleteInput = document.getElementById('searchAutocompl_input');
						          var clearButton = document.querySelector('.autocomplete-clear-button');
						          var loginButton = document.getElementById('login');
						          
						          if (autoCompleteInput) {
						            if(clearButton){
						                    var inputLength = autoCompleteInput.value.trim().length;
						                    if (inputLength >= 1) {
						                        clearButton.style.display = 'block';
						                    } else {
						                        clearButton.style.display = 'none';
						                    }
						            }
						            
					                if (loginButton) {
						                if (inputLength >= 3) {
						                    loginButton.disabled = false;  
							            } else {
							                loginButton.disabled = true;
							            }
					                }
								}
					        }
					
					        document.addEventListener('DOMContentLoaded', function() {
					            var autoCompleteInput = document.getElementById('searchAutocompl_input');
					            
					            if (autoCompleteInput) {
					                autoCompleteInput.addEventListener('input', updateClearButtonVisibility);
					                autoCompleteInput.addEventListener('blur', updateClearButtonVisibility);
					                autoCompleteInput.addEventListener('change', updateClearButtonVisibility);
					                updateClearButtonVisibility();
					            }
					        });
						</h:outputScript>
						<p:outputLabel for="@previous" value="#{messages['search_filter']}" />
					</span>
				</h:panelGroup>
				<h:panelGroup rendered="#{not discoveryLoginBean.largeList}">
					<p:focus conext="baseData" for="selectBox" />
					<p:selectOneListbox id="selectBox" class="loginList" style="width: 100%;" value="#{discoveryLoginBean.selected}" converter="#{userProvisionerCachedEntryConverter}"
							filter="true" filterMatchMode="contains" filterNormalize="true">
						<f:selectItems value="#{discoveryLoginBean.allList}" var="idp" itemLabel="#{idp.displayName}" itemValue="#{idp}"/>
						<p:ajax update=":form:infoPnl,:form:btnPanel" />
					</p:selectOneListbox>
				</h:panelGroup>
				<h:panelGroup layout="block">
					<p:selectBooleanCheckbox style="margin-top: 1em; font-size:0.9em;" value="#{discoveryLoginBean.storeIdpSelection}" itemLabel="#{messages.store_idp_selection}" />
				</h:panelGroup>
			</div>
			<div style="margin-top: 0em;" class="col-12 xs:col-12 sm:col-12 md:col-6 lg:col-6 xl:col-6">
			</div>
			<div style="display: flex; align-items: center; justify-content: space-between;" >
			<div style="margin-top: 0em; width: 100%;" class="col-12 xs:col-6 sm:col-6">
				<h:panelGroup id="btnPanel" styleClass="form">
					<p:commandButton id="login" style="margin-top: 0em; width:100%;" action="#{discoveryLoginBean.login}" 
					value="#{messages.proceed}" disabled="#{empty discoveryLoginBean.selected}"
						update=":form" />
				</h:panelGroup>
					                 
			</div>
			<div style="margin-top: 0em;" class="col-12 xs:col-6 sm:col-6">
				<h:panelGroup id="infoPnl">
					<p:panel style="margin:0.5em;" rendered="#{not empty discoveryLoginBean.selected}">
						<p:commandLink action="#{discoveryLoginBean.login(discoveryLoginBean.selected.id)}">
							<div style="text-align: left;">
								<p:graphicImage style="max-width: 320px; max-height: 2.8em;"
								 value="#{request.contextPath}/rest/icon-cache/sync/small/#{discoveryLoginBean.selected.iconLargeId}" alt="Organization logo"/>
							</div> 
						</p:commandLink> 
					</p:panel>
				</h:panelGroup>
			</div>	
			</div>
		</div>

		<h:panelGroup rendered="#{discoveryLoginBean.extraList.size() > 0}">
			<div style="margin-top: 3.5em;"><h:outputText value="#{messages['discovery.alternatives']}:" /></div>
			<div style="margin-top: 0.5em;" class="grid">
				<ui:repeat var="extra" value="#{discoveryLoginBean.extraList}">
					<div class="col-12 md:col-6 lg:col-2 xl:col-2" style="text-align:center; margin: 0.5em; border: 1px solid #eeeeee;">
						<p:commandLink action="#{discoveryLoginBean.login(extra.id)}">
							<div>
								<p:graphicImage style="max-width: 160px; max-height: 24px;" value="#{request.contextPath}/rest/icon-cache/sync/small/#{extra.iconLargeId}" alt="Organization logo"/>
							</div>
							<div>#{extra.displayName}</div>
						</p:commandLink>
					</div>
				</ui:repeat>
			</div>
		</h:panelGroup>
	</h:form>
	
	</ui:define>
</ui:composition>

 
</body>
</html>
